#1. Definir la variable 'vertices' como el nmero de nodos de la red.


Redq<-matrix(ncol=vertices,nrow=vertices)
Redg<-matrix(ncol=vertices,nrow=vertices)

#2. Ingresar las entradas correspondientes a cada arco antes de la seccin de FUNCIONES.


#######################

FUNCIONES

#######################

#---------------------------------------------
# CONSTRUYENDO LA RED AUXILIAR DE COSTOS
#---------------------------------------------
# Construimos la red auxiliar para localizar circuitos de costo negativo, por lo tanto a cada arco se asocia $c'_{ij}$$

AuxiliarCostos<-function(RedAuxCostos)
{
for(i in 1:vertices)
{
	for(j in 1:vertices)
	{
	if(FEntrante[i,j]>=0 && FEntrante[i,j]<Redq[i,j] && !is.na(FEntrante[i,j])) #El arco est saturado
		RedAuxCostos[i,j]<--log(Redg[i,j])
	if(FEntrante[i,j]>0 && FEntrante[i,j]<=Redq[i,j] && !is.na(FEntrante[i,j])) 
		RedAuxCostos[j,i]<--log(1/Redg[i,j])
	}
}
return(RedAuxCostos)
}

#####################################

ALGORITMO DE FLOYD

#####################################

# Utilizamos este algoritmo como subrutina auxiliar de rutas ms cortas.

CFloyd<-function(RedAuxCostos)
{
for(i in 1:vertices)
{
	for(j in 1:vertices)
	{
	if(j!=i)
	C[i,j]<-RedAuxCostos[i,j]
	C[i,i]<-0
	if(is.na(C[i,j]))
	C[i,j]<-Inf
	}
}
return(C)
}

zFloyd<-function()
{
for(i in 1:vertices)
{
	for(j in 1:vertices)
	{
	z[i,j]<-i
	}
}
return(z)
}

#-----------------------------------------------------------------------------------#
#						ALGORITMO DE FLOYD					
#-----------------------------------------------------------------------------------#
Floyd<-function(C,z)
{
for(k in 1:vertices)
{
for(i in 1:vertices)
{
	for(j in 1:vertices)
	{
		if(i!=k && j!=k)
		{
		w<- min(C[i,j],(C[i,k]+C[k,j]))
		C[i,j]<-w
		if(C[i,j]!=Inf)
		if(C[i,j]==(C[i,k]+C[k,j]))
		z[i,j]<- z[k,j]
		}		
	}
	hayciclo<-0
	if(C[i,i]<0 && z[i,i]!=i)
	{
		hayciclo<-1
	}
}	
cat("\n Para la iteracin k=",k,"tenemos: \n ")
cat("C= \n")
print(C)
cat("z= \n")
print(z)
if(hayciclo==1)
	break 

}
return(z)
}

############################################################
#Cuando se utiliza por primera vez se detecta el primer ciclo activo con la cadena aumentante que va de un $x_i \in \xi$ a $t$.
#Como se est trabajando con la red auxiliar, esto equivale a recuperar el circuito de costo negativo y la ruta de alguno de los nodos a t utilizando la matriz de predecesores.

#RECUPERANDO EL CICLO ACTIVO

############################################################
RecuperaCiclo<-function(Circuito,inicio)
{
Circuito<-matrix(ncol=vertices+2,nrow=1)
for(m in 1:vertices)
{
	if(z[m,m]!=m)
		{i<-m
		break}
}

if(inicio!=0)
{
	i<-inicio
}
j<-i
Circuito[1,1]<-i
for(c1 in 2:vertices)
{
	auxiliar<-z[i,j]
	Circuito[1,c1]<-z[i,j]
	if(auxiliar==i)
		break
	j<-auxiliar
}

for(i in 1:vertices+2)
{
	if(is.na(Circuito[1,i]))
		{auxiliar<-(i-1)
		break}
}

Circuito2<-matrix(ncol=vertices+2,nrow=1)
for(j in 1:(i-1))
{
	Circuito2[1,j]<-Circuito[1,i-1]
	i<-i-1
	if(i==0)
		break
}
for(m in 1:vertices+2)
{
	if(is.na(Circuito2[1,m]))
		break
}
indicador<-0
repetido<-0
for(j in 1:auxiliar)
{
	if(j<(auxiliar-2) && !is.na(Circuito2[1,j]) && !is.na(Circuito2[1,j+2]) && Circuito2[1,j]==Circuito2[1,j+2])
		{
		Circuito2[1,j]<-NA
		indicador<-1
		repetido<-repetido+1
		}
	if(repetido==2)
		{	
		Circuito2[1,j+1]<-vertices
		Circuito2[1,j]<-Circuito[1,1]
		break
		}
}
if (indicador==1)
{
	Circuito3<-matrix(ncol=vertices+2,nrow=1)
	for(m in 1:vertices+2)
	{
	if(!is.na(Circuito2[1,m]))
		break
	}
	for(i in 0:vertices+1)
	{
	if((i+m-1)>vertices)
		break
	if(is.na(Circuito2[1,0+m-1]))
		Circuito2[1,i+1]<-Circuito2[1,m+i-1]
	}
}
if (indicador==0)
	Circuito<-Circuito2
if(Circuito[1,1]==Circuito[1,3])
	Circuito<-matrix(ncol=vertices+2,nrow=1)

return(Circuito)
}
###############################################################

RECUPERANDO LA CADENA AUMENTANTE

################################################################

#Se recupera la cadena aumentante utilizando la matriz de predecesores

RecuperaCA<-function(Cadena,z)
{
i<-Circuito[1,1]
if(!is.na(Redq[i,vertices]) && FEntrante[i,vertices]<Redq[i,vertices])
{
	Cadena[1,1]<-i
	Cadena[1,2]<-vertices
}
else
{
Cadena[1,1]<-vertices
j<-vertices
FormaParte<-0
for(columna in 2:ncol(Cadena))
{
	if(Circuito[1,columna]==vertices && !is.na(Circuito[1,columna]))
	{
	FormaParte<-1
	print("El nodo final forma parte del ciclo activo")
	break
	}
}
if(FormaParte!=1)
{
for(columna in 2:ncol(Cadena))
{
	if(z[i,j]!=i)
	{
		Cadena[1,columna]<-z[i,j]
		j<-z[i,j]
	}
	if(z[i,j]==i)
		break
	
}		
Cadena<-Voltea(Cadena,FormaParte)
}
}
return(Cadena)
}

##############################
# FUNCION QUE VOLTEA LA CADENA
###############################

Voltea<-function(Cadena,FormaParte)
{
	Cadena2<-matrix(ncol=vertices+1,nrow=1)
	if(FormaParte!=1)
	{
		for(i in 1:ncol(Cadena))
		{
		if(is.na(Cadena[1,i]))
		break
		}
		Cadena2[1,1]<-Circuito[1,1]
		for (j in 1:i)
		{	
		if(i-j==0)
			break
		Cadena2[1,j+1]<-Cadena[1,i-j]
		}
	}
return(Cadena2)
}

###############################
# FUNCION QUE VALIDA LA CADENA
###############################

Validar<-function(Cadena,z)
{	
	#Cadena<-RecuperaCA(Cadena,z)
	Validador<-0
	for(j in 1:ncol(Cadena))
	{
		if(is.na(Cadena[1,j]))
			break
	}
		if(j==1)
			{
			Validador<-0
			}
		if(j>1 && !is.na(Cadena[1,j-1]) && Cadena[1,j-1]!=vertices)
			{
			Validador<-0
			}
		if(!is.na(Cadena[1,2]) && Cadena[1,2]==Circuito[1,2])
			{
			Validador<-0
			}
		if(!is.na(Cadena[1,2]) && !is.na(Circuito[1,3]) && Cadena[1,2]==Circuito[1,3])
			{
			Validador<-0
			}
		if(j>1 && !is.na(Cadena[1,j-1]) &&  !is.na(Circuito[1,3]) && Cadena[1,j-1]==vertices && !is.na(Cadena[1,2]) && Cadena[1,2]!=Circuito[1,2] && Cadena[1,2]!=Circuito[1,3])
			{
			Validador<-1
			}
		if(is.na(Cadena[1,2]) && Circuito[1,1]==vertices && !is.na(Circuito[1,1]))
			{
			Validador<-1
			}
	return(Validador)
}



##############################################################
# Concatenamos el ciclo activo (circuito negativo) y la cadena.


Concatenar<-function(CicloCadena)
{
for(i in 1:ncol(Circuito))
{
	CicloCadena[1,i]<-Circuito[1,i]
	if(is.na(CicloCadena[1,i]))
	{
	j<-i-1
	break
	}
}
for(i in 1:vertices)
{
	if(is.na(Cadena[1,i]))
	break
	CicloCadena[1,j+i]<-Cadena[1,i+1]
}
return(CicloCadena)
}

##############################################################

# El siguiente paso es calcular la cantidad de flujo delta que puede pasar a travs del ciclo activo y la cadena aumentante.

# CALCULANDO GANANCIAS

# La matriz gnodo tiene los vrtices del ciclo activo y de la cadena aumentante en el primer rengln, en el segundo rengln est la ganancia por vrtice y en el tercer rengln se muestra la capacidad incremental de cada arco.

##############################################################

FunGnodo<-function(gnodo)
{
for (j in 1:ncol(CicloCadena))
{

		gnodo[1,j]<-CicloCadena[1,j]
}

for(j in 1:ncol(CicloCadena))
{
	if(j==1)
	gnodo[2,1]<-1
	if(j>=2)
	{
	if (is.na(Redg[gnodo[1,j-1],gnodo[1,j]]))
		gnodo[2,j]<-(1/(Redg[gnodo[1,j],gnodo[1,j-1]]))*gnodo[2,j-1]		
	if (!is.na(Redg[gnodo[1,j-1],gnodo[1,j]]))
		gnodo[2,j]<-Redg[gnodo[1,j-1],gnodo[1,j]]*gnodo[2,j-1]
	if(!is.na(gnodo[2,j]) && gnodo[1,j]==gnodo[1,1])
		gnodo[2,j]<-gnodo[2,j]-1		
	}
}

#++++++
# CALCULANDO LA CAPACIDAD INCREMENTAL DE CADA ARCO
#++++++

for(j in 1:(ncol(CicloCadena)-1))
{
	if (is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
		gnodo[3,j]<-FSaliente[gnodo[1,j+1],gnodo[1,j]]/gnodo[2,j]	
	if (!is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
		gnodo[3,j]<-(Redq[gnodo[1,j],gnodo[1,j+1]]-FEntrante[gnodo[1,j],gnodo[1,j+1]])/gnodo[2,j]
}

return(gnodo)
}


#+++++
# SELECCIONAMOS DELTA (El mnimo de las capacidades incrementales por arco)
#+++++

CalculaDelta<-function(delta,gnodo)
{
	#El siguiente ciclo nos dice cuantos nmeros antes de un NA
	for (i in 1:ncol(gnodo))
	{
	if(is.na(gnodo[3,i]))
	break
	}
	i<-i-1
	#La matriz auxiliarDelta sirve para seleccionar el menor delta posible.
	auxiliarDelta<-matrix(nrow=1,ncol=i)
	for(j in 1:ncol(auxiliarDelta))
	{
 		auxiliarDelta[1,j]<-gnodo[3,j]
	}
	delta<-min(auxiliarDelta)
return(delta)
}


###################################################################
# RESUMEN DE LA ITERACIN
####################################################################


Resumen<-function()
{
cat("\n gnodo= \n")
print(gnodo)
cat("\n delta= ",delta,"\n")
cat("\n FEntrante= \n")
print(FEntrante)
cat("\n FSaliente= \n")
print(FSaliente)
g<-ganancia(FSaliente)
cat("\n La ganancia final de la red R es:",g,"\n")
}


# Volvemos a repetir desde Floyd para ver si la red an tiene ciclos activos. 
# Una vez eliminados, sigue maximizar el flujo actual sobre la red del nodo inicial al final.
# Para lograrlo, utilizamos como subrutina el algoritmo de Floyd de Rutas ms cortas.


####################################################################
RED AUXILIAR DE CAPACIDADES
####################################################################

RedCapacidades<-function(RedAuxCapacidades,FEntrante)
{
for(i in 1:vertices)
{
	for(j in 1:vertices)
	{
	if(FEntrante[i,j]>=0 && FEntrante[i,j]<Redq[i,j] && !is.na(FEntrante[i,j])) #El arco est saturado
		RedAuxCapacidades[i,j]<-Redq[i,j]-FEntrante[i,j]
	if(FEntrante[i,j]>0 && FEntrante[i,j]<=Redq[i,j] && !is.na(FEntrante[i,j])) 
		RedAuxCapacidades[j,i]<-FEntrante[i,j]*Redg[i,j]
	}
}
return(RedAuxCapacidades)
}

#---------------------------------------------------
# Recuperando la cadena aumentante inversa de s a t
#----------------------------------------------------

RecuperaCA2<-function(CadenaAumentante,z)
{
for(j in 0:vertices)
{	
	if(j==0)
	valor<-z[1,vertices]	
	if(j>0)
	valor<-z[1,valor]
	if(valor==1)
	{
		CadenaAumentante[1,j+1]<-z[1,valor]
		break
	}
	CadenaAumentante[1,j+1]<-valor
	
}
a<-CadenaAumentante[1,1]
b<-CadenaAumentante[1,2]
try(for(j in 3:vertices+1)
{
	if(!is.na(CadenaAumentante[1,j]) || CadenaAumentante[1,j]==a || CadenaAumentante[1,j+1]==b)
	{
	CadenaAumentante[1,j]<-NA
	}
})
CadenaAumentante[1,vertices+1]<-NA


for(j in 1:vertices)
{
	if(j>1 && !is.na(CadenaAumentante[1,j]) && CadenaAumentante[1,j]==CadenaAumentante[1,j-1])
	{
	CadenaAumentante[1,j]<-CadenaAumentante[1,j+1]
	}
}

for(j in 1:vertices)
{
	if(!is.na(CadenaAumentante[1,j]) &&  !is.na(CadenaAumentante[1,j+2]) && CadenaAumentante[1,j]==CadenaAumentante[1,j+2])
	{
	CadenaAumentante[1,j]<-NA
	for(ind in j:vertices)
	{
	CadenaAumentante[1,ind]<-CadenaAumentante[1,ind+1]
	}
	}
}
for(j in 1:vertices)
{
if(j>2 && is.na(CadenaAumentante[1,j]) && !is.na(CadenaAumentante[1,j-1])&& CadenaAumentante[1,j-1]!=1)
{
CadenaAumentante[1,j]<-1
break
}
}

################################
# VOLTEANDO LA CADENA AUMENTANTE
################################

CadenaAumentante2<-matrix(ncol=vertices+1,nrow=1)
for(i in 0:vertices)
{
	if(vertices-i>0 && !is.na(CadenaAumentante[1,vertices-i]))
	break
}

if(!is.na(CadenaAumentante[1,vertices-i]))
CadenaAumentante[1,vertices-i+1]<-1

for(j in 0:vertices-i)
{
	if(vertices-i+1-j>0)
	CadenaAumentante2[1,j]<-CadenaAumentante[1,vertices-i-j+1]
}
CadenaAumentante2[1,vertices-i+1]<-vertices
CadenaAumentante<-CadenaAumentante2

return(CadenaAumentante)
}


#---------------------------------------------------------
# CAPACIDAD INCREMENTAL DE LA CADENA
# La matriz gnodo2 es igual a gnodo que se utiliz para actualizar el flujo a travs de los ciclos activos.
#---------------------------------------------------------

FunGnodo2<-function(gnodo2)
{
gnodo2<-matrix(ncol=ncol(CadenaAumentante),nrow=3)
for (j in 1:ncol(CadenaAumentante))
{

		gnodo2[1,j]<-CadenaAumentante[1,j]
}
for(j in 1:ncol(CadenaAumentante))
{
	if(j==1)
	gnodo2[2,1]<-1
	if(j>=2)
	{
	if (is.na(Redg[gnodo2[1,j-1],gnodo2[1,j]]))
		gnodo2[2,j]<-(1/(Redg[gnodo2[1,j],gnodo2[1,j-1]]))*gnodo2[2,j-1]		
	if (!is.na(Redg[gnodo2[1,j-1],gnodo2[1,j]]))
		gnodo2[2,j]<-Redg[gnodo2[1,j-1],gnodo2[1,j]]*gnodo2[2,j-1]	
	if(!is.na(gnodo2[2,j]) && gnodo2[1,j]==gnodo2[1,1])
		gnodo2[2,j]<-gnodo2[2,j]-1	
	}
}

#---------------------------------------------------------------
# CALCULANDO LA CAPACIDAD INCREMENTAL DE CADA ARCO DE LA CADENA AUMENTANTE
#----------------------------------------------------------------

for(j in 1:(ncol(CadenaAumentante)-1))
{
	if (is.na(Redq[gnodo2[1,j],gnodo2[1,j+1]]))
		gnodo2[3,j]<-FSaliente[gnodo2[1,j+1],gnodo2[1,j]]/gnodo2[2,j]	
	if (!is.na(Redq[gnodo2[1,j],gnodo2[1,j+1]]))
		gnodo2[3,j]<-(Redq[gnodo2[1,j],gnodo2[1,j+1]]-FEntrante[gnodo2[1,j],gnodo2[1,j+1]])/gnodo2[2,j]
}
return(gnodo2)
}


#-------------------------------------
# CALCULANDO LA GANANCIA FINAL
#-------------------------------------
ganancia<-function(FSaliente)
{
	g<-0
	for(i in 1:vertices)
	{
	if(!is.na(FSaliente[i,vertices]))
			g<-FSaliente[i,vertices]+g
	}
	return(g)
}


#############################################################################################################

PROCEDIMIENTO: FLUJO MXIMO EN REDES CON GANANCIAS

#############################################################################################################

iteracion<-1
Parte1<-1
for(iteracion in 1:15)
{
if(iteracion==1)
{
	FEntrante<-matrix(ncol=vertices,nrow=vertices)
	FSaliente<-matrix(ncol=vertices,nrow=vertices)
	for(i in 1:vertices)
	{
		for(j in 1:vertices)
		{
		if(!is.na(Redq[i,j]))
			FEntrante[i,j]<-0
		FSaliente[i,j]<-FEntrante[i,j]*Redg[i,j]
		}
	}
}
if(Parte1==1)
{
	RedAuxCostos<-matrix(ncol=vertices,nrow=vertices)
	RedAuxCostos<-AuxiliarCostos(RedAuxCostos)
	C<-matrix(ncol=vertices,nrow=vertices)
	C<-CFloyd(RedAuxCostos)
	inicio<-0	

	if(iteracion==1)
	{
	z<-matrix(0,ncol=vertices,nrow=vertices)
	z<-zFloyd()
	z<-Floyd(C,z)
	Circuito<-matrix(ncol=vertices+1,nrow=1)
	Circuito<-RecuperaCiclo(Circuito,inicio)
	}

	if(iteracion>1 && cadenasaturada!=1)
	{
	z<-matrix(0,ncol=vertices,nrow=vertices)
	z<-zFloyd()
	z<-Floyd(C,z)
	Circuito<-matrix(ncol=vertices+1,nrow=1)
	Circuito<-RecuperaCiclo(Circuito,inicio)
	}
	
	if(iteracion>1 && cadenasaturada==1)
	{
	z<-Floyd(C,z)
	Circuito<-RecuperaCiclo(Circuito,inicio)
	}
	
	Cadena<-matrix(ncol=vertices+1,nrow=1)
	Cadena<-RecuperaCA(Cadena,z)
	Validador<-Validar(Cadena,z)	
	contador<-1

	Circuito2<-matrix(ncol=vertices+1,nrow=1)
	Circuito2<-Circuito

	if(is.na(Circuito2[1,1]))
		Validador<-1	

	while(Validador==0)	
	{
	inicio<-Circuito2[1,1+contador]
	Circuito<-matrix(ncol=vertices+1,nrow=1)
	Circuito<-RecuperaCiclo(Circuito,inicio)		
	Cadena<-matrix(ncol=vertices+1,nrow=1)
	Cadena<-RecuperaCA(Cadena,z)
	Validador<-Validar(Cadena,z)
	contador<-contador+1
	}

	if(Validador==1)	
	{
	Cadena<-matrix(ncol=vertices+1,nrow=1)
	Cadena<-RecuperaCA(Cadena,z)
	}

	CicloCadena<-matrix(nrow=1,ncol=vertices+3)
	CicloCadena<-Concatenar(CicloCadena)

	gnodo<-matrix(ncol=ncol(CicloCadena),nrow=3)
	gnodo<-FunGnodo(gnodo)

	if(is.na(gnodo[3,1])==TRUE)
		Parte1<-0
	if(is.na(gnodo[3,1])!=TRUE)
	delta<-CalculaDelta(delta,gnodo)
	if(delta<=0)
		Parte1<-0
}

if(Parte1==0 )#Parte 2: Encontrar cadenas aumentantes de s a t y enviar la mayor cantidad de flujo sobre la red.
{	
	RedAuxCapacidades<-matrix(ncol=vertices,nrow=vertices)
	RedAuxCapacidades<-RedCapacidades(RedAuxCapacidades,FEntrante)
	C<-CFloyd(RedAuxCapacidades)

	z<-matrix(0,ncol=vertices,nrow=vertices)
	z<-zFloyd()
	z<-Floyd(C,z)

	CadenaAumentante<-matrix(ncol=vertices+1,nrow=1)
	CadenaAumentante<-RecuperaCA2(CadenaAumentante,z)
	gnodo2<-matrix(ncol=ncol(CadenaAumentante),nrow=3)
	gnodo2<-FunGnodo2(gnodo2)

	if(is.na(gnodo2[3,1])!=TRUE)
		delta<-CalculaDelta(delta,gnodo2)
	gnodo<-gnodo2
	if(is.na(gnodo2[3,1])==TRUE)
	{
		Resumen()
		break
	}
}

for(j in 1:vertices) #Actualizacin del flujo
{
	#Para j=1, es decir, donde empieza la cadena
	if(j==1 && !is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
	{
		FEntrante[gnodo[1,j],gnodo[1,j+1]]<-FEntrante[gnodo[1,j],gnodo[1,j+1]]+delta
		FSaliente[gnodo[1,j],gnodo[1,j+1]]<-FEntrante[gnodo[1,j],gnodo[1,j+1]]*Redg[gnodo[1,j],gnodo[1,j+1]]	
		EsForward<-1
	}
	#Si es un arco en sentido contrario
	if(j==1 && is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
	{
		FEntrante[gnodo[1,j+1],gnodo[1,j]]<-FSaliente[gnodo[1,j+1],gnodo[1,j]]-delta
		FSaliente[gnodo[1,j+1],gnodo[1,j]]<-FEntrante[gnodo[1,j+1],gnodo[1,j]]/Redg[gnodo[1,j+1],gnodo[1,j]]	
		EsForward<-0
	}
	#Para un nodo distinto al inicial
	if(j>=2 && !is.na(Redq[gnodo[1,j],gnodo[1,j+1]]) && !is.na(gnodo[1,j]))
	{
		x<-0
		y<-0
		for(i in 1:vertices)
		{
		if(EsForward==1 && !is.na(FSaliente[i,gnodo[1,j]]) && FSaliente[i,gnodo[1,j]]!=FSaliente[gnodo[1,j-1],gnodo[1,j]] && !is.na(FSaliente[gnodo[1,j-1],gnodo[1,j]]))
			x<-FSaliente[i,gnodo[1,j]]+x
		if(EsForward==0 && !is.na(FSaliente[i,gnodo[1,j]]) && FSaliente[i,gnodo[1,j]]!=FSaliente[gnodo[1,j],gnodo[1,j-1]] && !is.na(FSaliente[gnodo[1,j],gnodo[1,j-1]]))
			x<-FSaliente[i,gnodo[1,j]]+x
		if(!is.na(FEntrante[gnodo[1,j],i]) && FEntrante[gnodo[1,j],i]!=FEntrante[gnodo[1,j],gnodo[1,j+1]] && !is.na(FEntrante[gnodo[1,j],gnodo[1,j+1]]))
			y<-FEntrante[gnodo[1,j],i]+y
		}
		if(EsForward==1)
			FEntrante[gnodo[1,j],gnodo[1,j+1]]<-x-y+FSaliente[gnodo[1,j-1],gnodo[1,j]]
		if(EsForward==0) 
			FEntrante[gnodo[1,j],gnodo[1,j+1]]<-x-y
		if(is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
			EsForward<-0			
		if(!is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
			EsForward<-1		
		FSaliente[gnodo[1,j],gnodo[1,j+1]]<-FEntrante[gnodo[1,j],gnodo[1,j+1]]*Redg[gnodo[1,j],gnodo[1,j+1]]		
			
	}
	#Si es un arco en sentido contrario  && gnodo[1,j]!=gnodo[1,1]     
	if(j>=2 && is.na(Redq[gnodo[1,j],gnodo[1,j+1]]) && !is.na(gnodo[1,j]))
	{
		x<-0
		y<-0
		for(i in 1:vertices)
		{
		if(!is.na(FSaliente[i,gnodo[1,j]]) && !is.na(FSaliente[gnodo[1,j+1],gnodo[1,j]]))
			x<-FSaliente[i,gnodo[1,j]]+x
		if(!is.na(FEntrante[gnodo[1,j],i]) && FEntrante[gnodo[1,j],i]!=FEntrante[gnodo[1,j+1],gnodo[1,j]]/Redg[gnodo[1,j+1],gnodo[1,j]] && !is.na(FEntrante[gnodo[1,j+1],gnodo[1,j]]/Redg[gnodo[1,j+1],gnodo[1,j]]))
			y<-FEntrante[gnodo[1,j],i]+y
		}
		x<-x-FSaliente[gnodo[1,j+1],gnodo[1,j]]
		if(is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
			EsForward<-0			
		if(!is.na(Redq[gnodo[1,j],gnodo[1,j+1]]))
			EsForward<-1			
		if(EsForward==1)
			FEntrante[gnodo[1,j+1],gnodo[1,j]]<-x/Redg[gnodo[1,j+1],gnodo[1,j]]
		if(EsForward==0)
			FEntrante[gnodo[1,j+1],gnodo[1,j]]<-(y-x)/Redg[gnodo[1,j+1],gnodo[1,j]]
		FSaliente[gnodo[1,j+1],gnodo[1,j]]<-FEntrante[gnodo[1,j+1],gnodo[1,j]]*Redg[gnodo[1,j+1],gnodo[1,j]]
	} 	
}
for(j in 1:vertices)
{
	if(j<vertices && !is.na(Cadena[1,j]) && !is.na(Cadena[1,j+1]))
	{
	if(FEntrante[Cadena[1,j],Cadena[1,j+1]]==Redq[Cadena[1,j],Cadena[1,j+1]])
	{
		cadenasaturada<-1
		break
	}
	if(FEntrante[Cadena[1,j],Cadena[1,j+1]]!=Redq[Cadena[1,j],Cadena[1,j+1]])
		cadenasaturada<-0
	}
	if(j<vertices && is.na(Cadena[1,j]) && is.na(Cadena[1,j+1]))
		cadenasaturada<-1
}
cat("\n ------------ Iteracion= ",iteracion,"---------------- \n")
Resumen()
iteracion<-iteracion+1
readline(prompt="Presiona [enter] para continuar")
}